%define anolis_release 1
%global libname libsodium
%global soname  23

Name:           libsodium
Version:        1.0.18
Release: %{anolis_release}%{dist}
Summary:        The Sodium crypto library
License:        ISC
URL:            http://libsodium.org/
Source0:        http://download.libsodium.org/libsodium/releases/%{name}-%{version}.tar.gz

BuildRequires: gcc
BuildRequires: make

# manage update from 3rd party repository
Obsoletes:      %{libname}%{soname} <= %{version}

%description
Sodium is a new, easy-to-use software library for encryption, decryption, 
signatures, password hashing and more. It is a portable, cross-compilable, 
installable, packageable fork of NaCl, with a compatible API, and an extended 
API to improve usability even further. Its goal is to provide all of the core 
operations needed to build higher-level cryptographic tools. The design 
choices emphasize security, and "magic constants" have clear rationales.

The same cannot be said of NIST curves, where the specific origins of certain 
constants are not described by the standards. And despite the emphasis on 
higher security, primitives are faster across-the-board than most 
implementations of the NIST standards.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}
Obsoletes:      %{libname}%{soname}-devel <= %{version}

%description    devel
This package contains libraries and header files for
developing applications that use %{name} libraries.

%package        static
Summary:        Static library for %{name}
Requires:       %{name}-devel = %{version}-%{release}
Obsoletes:      %{libname}%{soname}-static <= %{version}

%description    static
This package contains the static library for statically
linking applications to use %{name}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q

%build
%define _lto_cflags -flto=auto -ffat-lto-objects

%configure \
  --disable-silent-rules \
  --disable-opt

%make_build

%install
%make_install
%generate_compatibility_deps

%check
make check

%files
%license LICENSE
%{_libdir}/%{libname}.so.%{soname}*

%dir %{abidir}
%{abidir}/%{libname}*.dump

%files devel
%doc test/default/*.{c,exp,h}
%doc test/quirks/quirks.h
%{_includedir}/sodium.h
%{_includedir}/sodium/
%{_libdir}/%{libname}.so
%{_libdir}/pkgconfig/%{libname}.pc

%files static
%{_libdir}/libsodium.a

%files doc
%doc AUTHORS ChangeLog README.markdown THANKS

%changelog
* Wed Mar 29 2023 Zhongling He <zhonglingh@linux.alibaba.com> - 1.0.18-1
- Init package from upstream
